package com.example.se.catornot2;
import android.content.Context;
import android.content.Intent;
import android.media.MediaPlayer;
import android.os.Build;
import android.os.Bundle;
import android.os.VibrationEffect;
import android.speech.RecognizerIntent;
import android.speech.tts.TextToSpeech;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.os.Vibrator;
import java.util.Arrays;
import java.util.List;
import java.util.Locale;
import java.util.Random;

public class MainActivity extends AppCompatActivity {
    private static final int SPEECH_REQUEST_CODE = 0;
    TextToSpeech tts;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        initializeTextToSpeech();


    }

    // This callback is invoked when the Speech Recognizer returns.
    // This is where you process the intent and extract the speech text from the intent.
    @Override
    protected void onActivityResult(int requestCode, int resultCode,
                                    Intent data) {
        if (requestCode == SPEECH_REQUEST_CODE && resultCode == RESULT_OK) {
            List<String> results = data.getStringArrayListExtra(
                    RecognizerIntent.EXTRA_RESULTS);
            String spokenText = results.get(0);
            processVoiceCommand(spokenText);
        }
        super.onActivityResult(requestCode, resultCode, data);
    }

    private void initializeTextToSpeech() {
        tts = new TextToSpeech(getApplicationContext(), new TextToSpeech.OnInitListener() {
            @Override
            public void onInit(int status) {
                if (status != TextToSpeech.ERROR) {
                    tts.setLanguage(Locale.US);
                }
            }
        });
    }

    // Fires, when speechButton is clicked
    public void handleSpeechButtonClick(View target) {
        displaySpeechRecognizer();
    }

    // Create an intent that can start the Speech Recognizer activity
    private void displaySpeechRecognizer() {
        Intent intent = new Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH);
        intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL,
                "en-US");
        // Start the activity, the intent will be populated with the speech text
        startActivityForResult(intent, SPEECH_REQUEST_CODE);
    }

    // Randomly picks a string from the list and tells the result
    private void randomizer(List<String> T) {
        // Randomly picks a string
        Random rand = new Random();
        String answer = T.get(rand.nextInt(T.size()));

        /*
        if statement with clue about result (vibration?),
        depending on whether answer = "It is a cat" or = "It is NOT a cat";
        thread must sleep for some time (3000ms-4000ms)
         */

        //vibrate if answer is 'It is a cat'

        if (answer.equals("It is a cat")){
            shakeItBaby();
        }


        // Says the result
        try {
            Thread.sleep(4000);
            tts.speak(answer, TextToSpeech.QUEUE_FLUSH, null);
        }catch(Exception e) {
        }
    }

    private void shakeItBaby() {
        if (Build.VERSION.SDK_INT >= 26) {
            ((Vibrator) getSystemService(VIBRATOR_SERVICE)).vibrate(VibrationEffect.createOneShot(500, VibrationEffect.DEFAULT_AMPLITUDE));
        } else {
            ((Vibrator) getSystemService(VIBRATOR_SERVICE)).vibrate(500);
        }
    }



    // Process voice command given by user
    private void processVoiceCommand(String spokenText) {
        if (spokenText.contains("photo") || spokenText.contains("foto")) {

            // camera shutter sound (?); indication of app taking a photo
            MediaPlayer mySound;
            mySound= MediaPlayer.create(MainActivity.this,R.raw.photosound);
            mySound.start();
            // Starting question
            try {
                Thread.sleep(3000);
                String question = "Is it a cat or not?";
                tts.speak(question, TextToSpeech.QUEUE_FLUSH, null);
            }catch(Exception e) {
            }
            // Initiating randomizer method on 'answers'
            List<String> answers = Arrays.asList("It is a cat", "It is NOT a cat");
            randomizer(answers);
        }
    }
}
